import java.awt.*;
import javax.swing.*;
import javax.swing.table.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.util.*;

//----------------------------------------------------------------------

abstract class Note {
	double length;           // the length of the whole Notes.
	int    width;            // the width of the whole Notes.
	Field  field;            // the field this class belongs to.
	int    horizonPosition;  // the horizon position of this note in the field.

	abstract void paintNote();
	abstract void halveNoteWithoutUndo();
	abstract void halveNoteWithUndo(Undo undo);
	abstract void doubleNoteWithoutUndo();
	abstract void doubleNoteWithUndo(Undo undo);	
}

abstract class Primitive extends Note {
	int type;
	int numDot;

	abstract void removeAllModificationWithoutUndo();
	abstract void removeAllModificationWithUndo(Undo undo);
	abstract void addDotWithoutUndo();
	abstract void addDotWithUndo(Undo undo);
	abstract void removeDotWithoutUndo();
	abstract void removeDotWithUndo(Undo undo);

	// ߥä֤
	// 1 ---> 4 * 60000 / tempo
	
	public int getTime(int tempo) {
		System.out.println("Length : " + length);
		return (int)((length * 240000) / tempo);
	}
}

//----------------------------------------------------------------------------------------------------

class BeamedNote extends Note {

	LinkedList notes;

	//----------------------------------------------------------------------

	BeamedNote(Field f, LinkedList ns) {
		field = f;
		horizonPosition = ((BasicNote)ns.getFirst()).horizonPosition;
		notes = ns;
		recalculateWidthLength();
	}

	//----------------------------------------------------------------------

	private void recalculateWidthLength() {
		ListIterator it = notes.listIterator();
		while (it.hasNext()) {
			Note note = (Note)it.next();
			length += note.length;
			width  = note.horizonPosition + note.width;
		}
		width -= ((Note)notes.getFirst()).horizonPosition;
	}

	//----------------------------------------------------------------------
	
	private static int getAdjustment(int t) {
		switch(t) {
		case BasicNote.NOTE8:
			return 0;
		case BasicNote.NOTE16:
			return 8;
		case BasicNote.NOTE32:
			return 16;
		default:
			return 0;
		}
	}

	//----------------------------------------------------------------------
	
	// ȾüʤťɤʤΤǡɤΤѤ衩
	public void paintNote(BasicNote left, BasicNote mid, BasicNote right,
						  double grad, int intercept, int direction) {

		// Ūˡʬκ¦ФҤ褦ˤ롣
		Graphics g = Main.getGraphics();
		int y      = mid.getY();

		g.setColor(Color.black);

		// ޤnotehead 
		mid.paintNotehead();

		// 岼Ǿ櫓򤷤
		if (direction >= 0) {
			//  VerticalLine 
			double beamedY = grad * mid.horizonPosition + intercept - 30;
			g.drawLine(mid.horizonPosition + 11, y, mid.horizonPosition + 11, (int)beamedY);
			Graphics2D g2 = (Graphics2D)g;
			g2.setStroke(Main.fifthtimesStroke);
			// beam 
			if (left == null) { // ֺ¦ Note
				int t = BasicNote.NOTE8;
				while (t <= BasicNote.NOTE32) {
					if (t > mid.type || t <= right.type) { // ʤƤɤ

					} else { // ûɤ
						int adjustment = getAdjustment(t);
						double ly = grad * mid.horizonPosition + intercept - 30 + adjustment;
						double ry = grad * (mid.horizonPosition + 7) + intercept - 30 + adjustment;
						g2.draw(new Line2D.Double(mid.horizonPosition + 13, ly,
												  mid.horizonPosition + 20, ry));
					}

					t *= 2;
				}
			} else if (right == null) { // ֱ¦
				int t = BasicNote.NOTE8;

				while (t <= BasicNote.NOTE32) {
					if (t > mid.type) { // ʤƤɤ

					} else if (t <= left.type) { // ʤФʤʤ
						int adjustment = getAdjustment(t);
						double my = grad * mid.horizonPosition + intercept - 30 + adjustment;
						double ly = grad * left.horizonPosition + intercept - 30 + adjustment;
						g2.draw(new Line2D.Double(left.horizonPosition + 13, ly,
												  mid.horizonPosition + 9, my));
					} else { // ûɤ
						int adjustment = getAdjustment(t);
						double my = grad * mid.horizonPosition + intercept - 30 + adjustment;
						double ly = grad * (mid.horizonPosition - 7) + intercept - 30 + adjustment;
						g2.draw(new Line2D.Double(mid.horizonPosition + 2, ly,
												  mid.horizonPosition + 9, my));
					}
					t *= 2;
				}

			} else { // 
				int t = BasicNote.NOTE8;

				while (t <= BasicNote.NOTE32) {
					if (t > mid.type) { // ʤɤ

					} else if (t <= left.type) { // ʤФʤʤ
						int adjustment = getAdjustment(t);
						double my = grad * mid.horizonPosition + intercept - 30 + adjustment;
						double ly = grad * left.horizonPosition + intercept - 30 + adjustment;
						g2.draw(new Line2D.Double(left.horizonPosition + 13, ly,
												  mid.horizonPosition + 9, my));
					} else if (t <= right.type) {

					} else { // ûɤ
						int adjustment = getAdjustment(t);
						double my = grad * mid.horizonPosition + intercept - 30 + adjustment;
						double ly = grad * (mid.horizonPosition - 7) + intercept - 30 + adjustment;
						g2.draw(new Line2D.Double(mid.horizonPosition + 2, ly,
												  mid.horizonPosition + 9, my));
					}

					t *= 2;
				}
			}
		} else {
			// VerticalLine
			double beamedY = grad * mid.horizonPosition + intercept + 35;
			g.drawLine(mid.horizonPosition, y + 5, mid.horizonPosition, (int)beamedY);
			Graphics2D g2 = (Graphics2D)g;
			g2.setStroke(Main.fifthtimesStroke);
			if (left == null) { // ֺ¦ Note
				int t = BasicNote.NOTE8;
				while (t <= BasicNote.NOTE32) {
					if (t > mid.type || t <= right.type) { // ʤƤɤ

					} else { // ûɤ
						int adjustment = getAdjustment(t);
						double ly = grad * mid.horizonPosition + intercept + 34 - adjustment;
						double ry = grad * (mid.horizonPosition + 7) + intercept + 34 - adjustment;
						g2.draw(new Line2D.Double(mid.horizonPosition + 2, ly,
												  mid.horizonPosition + 9, ry));
					}

					t *= 2;
				}
			} else if (right == null) { // ֱ¦
				int t = BasicNote.NOTE8;

				while (t <= BasicNote.NOTE32) {
					if (t > mid.type) { // ʤƤɤ

					} else if (t <= left.type) { // ʤФʤʤ
						int adjustment = getAdjustment(t);
						double my = grad * mid.horizonPosition + intercept + 34 - adjustment;
						double ly = grad * left.horizonPosition + intercept + 34 - adjustment;
						g2.draw(new Line2D.Double(left.horizonPosition + 2, ly,
												  mid.horizonPosition - 2, my));
					} else { // ûɤ
						int adjustment = getAdjustment(t);
						double my = grad * mid.horizonPosition + intercept + 34 - adjustment;
						double ly = grad * (mid.horizonPosition - 7) + intercept + 34 - adjustment;
						g2.draw(new Line2D.Double(mid.horizonPosition - 9, ly,
												  mid.horizonPosition - 2, my));
					}
					t *= 2;
				}

			} else { // 
				int t = BasicNote.NOTE8;

				while (t <= BasicNote.NOTE32) {
					if (t > mid.type) { // ʤɤ

					} else if (t <= left.type) { // ʤФʤʤ
						int adjustment = getAdjustment(t);
						double my = grad * mid.horizonPosition + intercept + 34 - adjustment;
						double ly = grad * left.horizonPosition + intercept + 34 - adjustment;
						g2.draw(new Line2D.Double(left.horizonPosition + 2, ly,
												  mid.horizonPosition - 2, my));
					} else if (t <= right.type) {

					} else { // ûɤ
						int adjustment = getAdjustment(t);
						double my = grad * mid.horizonPosition + intercept + 34 - adjustment;
						double ly = grad * (mid.horizonPosition - 7) + intercept + 34 - adjustment;
						g2.draw(new Line2D.Double(mid.horizonPosition - 9, ly,
												  mid.horizonPosition - 2, my));
					}

					t *= 2;
				}
			}
		}

	}

	//----------------------------------------------------------------------

	public void paintNote() {

		// ޤpitch ñĴ(+1)ñĴ(-1)ͭ(2)Τ줫򸫤롣
		// ޤ岼ɤˤ٤Ƚꤹ롣
		ListIterator it = notes.listIterator();
		int state = 0;
		int direction = 0;
		int lastPitch = ((BasicNote)it.next()).pitch;
		while (it.hasNext()) {
			BasicNote note = (BasicNote)it.next();
			if (note.isVerticalLineUpside()) {
				++direction;
			} else {
				--direction;
			}
			switch (state) {
			case 0:
				if (lastPitch == note.pitch) {
					break;
				} else if (lastPitch > note.pitch) {
					state = -1;
				} else if (lastPitch < note.pitch) {
					state = 1;
				}
				break;
			case 1:
				if (lastPitch > note.pitch) {
					state = 2;
				}
				break;
			case -1:
				if (lastPitch < note.pitch) {
					state = 2;
				}
				break;
			default:
				break;
			}
			lastPitch = note.pitch;
		}

		// ˴Ťơľη y Ҥ򻻽Ф롣
		// â NoteHead ˹ͤ롣
		double gradient = 0.0;
		int intercept   = 0;
		if (state == 1 || state == -1) { // ñĴä⤷ñĴΤȤ
			BasicNote firstNote = (BasicNote)notes.getFirst();
			BasicNote lastNote   = (BasicNote)notes.getLast();
			gradient = (double)(lastNote.getY() - firstNote.getY()) / (lastNote.horizonPosition - firstNote.horizonPosition);
			intercept = (int)(lastNote.getY() - gradient * lastNote.horizonPosition);
		} else {
			it = notes.listIterator();
			BasicNote firstNote = (BasicNote)notes.getFirst();
			intercept = firstNote.getY();
			if (direction >= 0) { // 
				while (it.hasNext()) {
					BasicNote note = (BasicNote)it.next();
					int y = note.getY();
					if (intercept > y) {
						intercept = y;
					}
				}
			} else { // 
				while (it.hasNext()) {
					BasicNote note = (BasicNote)it.next();
					int y = note.getY();
					if (intercept < y) {
						intercept = y;
					}
				}
			}
		}

		// (intercept)(gradient)뤳ȤǤ
		ListIterator lit       = notes.listIterator();
		BasicNote    leftNote  = null;
		BasicNote    midNote   = (BasicNote)lit.next();
		BasicNote    rightNote = (BasicNote)lit.next();
		Graphics     g         = Main.getGraphics();

		// ǽϡleftNote ФƤΤߥץФ褤 
		paintNote(null, midNote, rightNote, gradient, intercept, direction);

		// ʲmidNote Фƥץ
		while (lit.hasNext()) {
			leftNote  = midNote;
			midNote   = rightNote;
			rightNote = (BasicNote)lit.next();
			paintNote(leftNote, midNote, rightNote, gradient, intercept, direction);
		}

		// ǸϡmidNote Фƥץ롣
		paintNote(midNote, rightNote, null, gradient, intercept, direction);
	}

	//----------------------------------------------------------------------
	
	// ƤβĹȾʬˤ롣âʬ䤬ޤޤƤ顢̵뤹롣
	public void halveNoteWithoutUndo() {
		ListIterator it = notes.listIterator();
		while (it.hasNext()) {
			BasicNote note = (BasicNote)it.next();
			if (note.type < BasicNote.NOTE32) {
				note.halveNoteWithoutUndo();
			}
		}
		recalculateWidthLength();
	}

	public void halveNoteWithUndo(Undo undo) {
		ListIterator it = notes.listIterator();
		LinkedList ns = new LinkedList();
		while (it.hasNext()) {
			BasicNote note = (BasicNote)it.next();
			if (note.type < BasicNote.NOTE32) {
				note.halveNoteWithoutUndo();
				ns.add(note);
			}
		}
		recalculateWidthLength();
		undo.makeUndo(Undo.DOUBLE_NOTE, field, ns);
	}

	//----------------------------------------------------------------------
	
	// ƤβĹܤˤ롣âȬʬ̵뤹롣
	public void doubleNoteWithoutUndo() {
		ListIterator it = notes.listIterator();
		while (it.hasNext()) {
			BasicNote note = (BasicNote)it.next();
			if (note.type > BasicNote.NOTE8) {
				note.doubleNoteWithoutUndo();
			}			
		}
		recalculateWidthLength();
	}

	public void doubleNoteWithUndo(Undo undo) {
		ListIterator it = notes.listIterator();
		LinkedList ns = new LinkedList();
		while (it.hasNext()) {
			BasicNote note = (BasicNote)it.next();
			if (note.type > BasicNote.NOTE8) {
				note.doubleNoteWithoutUndo();
				ns.add(note);
			}
		}
		recalculateWidthLength();
		undo.makeUndo(Undo.HALVE_NOTE, field, ns);
	}

}


//----------------------------------------------------------------------

class Rest extends Primitive {

	static final Image rest4Image  = Main.toolkit.getImage("image/rest4.png");  // 12 * 41
	static final Image rest8Image  = Main.toolkit.getImage("image/rest8.png");  // 15 * 27
	static final Image rest16Image = Main.toolkit.getImage("image/rest16.png"); // 18 * 36
	static final Image rest32Image = Main.toolkit.getImage("image/rest32.png"); // 21 * 49

	static final int REST1 = 1;
	static final int REST2 = 2;
	static final int REST4 = 4;
	static final int REST8 = 8;
	static final int REST16 = 16;
	static final int REST32 = 32;

	//----------------------------------------------------------------------

	Rest(Field f, int t, int nd, int hp) {
		field  = f;
		type   = t;
		numDot = nd;
		horizonPosition = hp;
		recalculateWidthLength();
	}

	//----------------------------------------------------------------------
	
	private static int getAdjustment(int t) {
		switch (t) {
		case REST8:
			return 0;
		case REST16:
			return 8;
		case REST32:
			return 16;
		default:
			return 0;
		}
	}

	//----------------------------------------------------------------------
	
	private void recalculateWidthLength() {
		// length κƷ׻
		double d = 1.0;
		double sum = 0.0;
		int nd = numDot;
		while (nd >= 0) {
			sum += d;
			d /= 2;
			--nd;
		}
		length = (1.0 / type) * sum;
		
		width = 16;
		width += numDot * 7; // dot 򸫤
	}

	//----------------------------------------------------------------------
	
	public int getY() {
		return field.getY() + Field.MARGIN + 3;
	}

	//----------------------------------------------------------------------

	public void halveNoteWithoutUndo() {
		if (type == REST32) {
			return;
		}

		type *= 2;
		recalculateWidthLength();
	}

	public void halveNoteWithUndo(Undo undo) {
		if (type == REST32) {
			return;
		}

		type *= 2;
		recalculateWidthLength();
		undo.makeUndo(Undo.DOUBLE_NOTE, field, this);
	}

	//----------------------------------------------------------------------

	public void doubleNoteWithoutUndo() {
		if (type == REST1) {
			return;
		}
		type /= 2;
		recalculateWidthLength();
	}

	public void doubleNoteWithUndo(Undo undo) {
		if (type == REST1) {
			return;
		}

		type /= 2;
		recalculateWidthLength();
		undo.makeUndo(Undo.HALVE_NOTE, field, this);
	}
	
	//----------------------------------------------------------------------

	public void addDotWithoutUndo() {
		if (numDot >= 2) {
			return;
		} else {
			++numDot;
			recalculateWidthLength();
		}
	}

	public void addDotWithUndo(Undo undo) {
		if (numDot >= 2) {
			return;
		} else {
			++numDot;
			recalculateWidthLength();
			undo.makeUndo(Undo.REMOVE_DOT, field, this);
		}
	}

	//----------------------------------------------------------------------

	public void removeDotWithoutUndo() {
		if (numDot <= 0) {
			return;
		} else {
			--numDot;
			recalculateWidthLength();
		}
	}

	public void removeDotWithUndo(Undo undo) {
		if (numDot <= 0) {
			return;
		} else {
			--numDot;
			recalculateWidthLength();
			undo.makeUndo(Undo.ADD_DOT, field, this);
		}
	}

	//----------------------------------------------------------------------
	
	public void removeAllModificationWithoutUndo() {
		numDot = 0;
		recalculateWidthLength();
	}

	public void removeAllModificationWithUndo(Undo undo) {
		int value[] = { numDot };
		undo.makeUndo(Undo.REMOVE_DOT, value, field, this);
		numDot = 0;
	}

	//----------------------------------------------------------------------

	public void paintNote() {

		Graphics g = Main.getGraphics();
		switch (type) {
		case REST1:
			g.fillRect(horizonPosition,getY() + 8, 12, 3);
			return;			
		case REST2:
			// System.out.println("paintNote Rest2");
			g.fillRect(horizonPosition, getY() + 14, 12, 3);
			return;		
		case REST4:
			// System.out.println("paintNote Rest4");
			g.drawImage(rest4Image, horizonPosition, getY(), 12, 30, Main.root.mainPanel);			
			return;	
		case REST8:
			// System.out.println("paintNote Rest8");
			g.drawImage(rest8Image, horizonPosition, getY(), 15, 30, Main.root.mainPanel);
			return;	
		case REST16:
			// System.out.println("paintNote Rest16");
			g.drawImage(rest16Image, horizonPosition, getY(), 18, 30, Main.root.mainPanel);
			return;	
		case REST32:
			// System.out.println("paintNote Rest32");
			g.drawImage(rest32Image, horizonPosition, getY(), 21, 40, Main.root.mainPanel);
			return;	
		default:
			return;
		}

	}
}

//----------------------------------------------------------------------

class BasicNote extends Primitive {

	static final Image naturalImage = Main.toolkit.getImage("image/natural.png"); // 15 * 53
	static final Image flatImage    = Main.toolkit.getImage("image/flat.png");    // 16 * 51
	static final Image sharpImage   = Main.toolkit.getImage("image/sharp.png");   // 18 * 57

	static final Image barbaImage     = Main.toolkit.getImage("image/barba.png");     // 19 * 58
	static final Image revbarbaImage  = Main.toolkit.getImage("image/revbarba.png");  // 19 * 58
	static final Image barbaImage2    = Main.toolkit.getImage("image/barba2.png");    // 19 * 75
	static final Image revbarbaImage2 = Main.toolkit.getImage("image/revbarba2.png"); // 19 * 75
	static final Image barbaImage3    = Main.toolkit.getImage("image/barba3.png");    // 19 * 73
	static final Image revbarbaImage3 = Main.toolkit.getImage("image/revbarba3.png"); // 19 * 73

	static final int NOTE1  = 1;
	static final int NOTE2  = 2;
	static final int NOTE4  = 4;
	static final int NOTE8  = 8;
	static final int NOTE16 = 16;
	static final int NOTE32 = 32;

	static final int NOT_MODIFIED = 0;
	static final int SHARP        = 1;
	static final int FLAT         = 2;
	static final int NATURAL      = 3;

	static final int pitchPositionY[] = {
		46 + Field.MARGIN, 46 + Field.MARGIN, 41 + Field.MARGIN, 41 + Field.MARGIN,
		36 + Field.MARGIN, 31 + Field.MARGIN, 31 + Field.MARGIN, 26 + Field.MARGIN,
		26 + Field.MARGIN, 21 + Field.MARGIN, 21 + Field.MARGIN, 16 + Field.MARGIN
	};

	int pitch;
	int staccato;
	int modification;

	//----------------------------------------------------------------------

	BasicNote(Field f, int p, int t, int nd, int hp) {
		field  = f;
		pitch  = p;
		type   = t;
		numDot = nd;

		horizonPosition = hp;
		modification = NOT_MODIFIED;

		staccato = 0;
		recalculateWidthLength();
	}

	//----------------------------------------------------------------------
	
	public boolean isVerticalLineUpside() {
		return ((field.cref == Field.TREBLE && pitch <= 69) 
				|| (field.cref == Field.BASS && pitch <= 50));
	}

	//----------------------------------------------------------------------
	
	private void recalculateWidthLength() {
		// length κƷ׻
		double d = 1.0;
		double sum = 0.0;
		int nd = numDot;
		while (nd >= 0) {
			sum += d;
			d /= 2;
			--nd;
		}
		length = (1.0 / type) * sum;
		
		// widthκƷ׻
		if (type == NOTE1 || type == NOTE2 || type == NOTE4) {
			width = 12;
		} else {
			width = 22;
		}
		// dot 򸫤
		width += numDot * 7;
	}

	//----------------------------------------------------------------------

	public int getRealPitch() {
		if (modification == SHARP) {
			return (pitch + 1);
		} else if (modification == FLAT) {
			return (pitch - 1);
		} else {
			return pitch;
		}
	}

	//----------------------------------------------------------------------

	// get Y position from pitch
	int getY() {
		// in cash TREBLE...
		// we can express 3 octaves.
		// the mid C pitch is '60'.
		if (field.cref == Field.TREBLE) {
			if (pitch < 48 || 84 <= pitch ) {
				Main.failwith("getY TREBLE : " + pitch);
				return -1;
			} else {
				return -35 * ((pitch - 48) / 12 - 1) + pitchPositionY[(pitch - 48) % 12] + field.getY();
			}
		} else if (field.cref == Field.BASS) {
			if (pitch < 28 || 62 < pitch) {
				Main.failwith("getY BASS : " + pitch);
				return -1;
			} else {
				return -35 * ((pitch - 24) / 12 - 1) + pitchPositionY[(pitch - 24) % 12] 
					+ field.getY() + 10;
			}
		} 

		Main.failwith("getY");
		return -1;
	}

	//----------------------------------------------------------------------

	public void halveNoteWithoutUndo() {
		if (type == NOTE32) {
			return;
		}
		type *= 2;
		recalculateWidthLength();
	}

	public void halveNoteWithUndo(Undo undo) {
		if (type == NOTE32) {
			return;
		}
		type *= 2;
		recalculateWidthLength();
		undo.makeUndo(Undo.DOUBLE_NOTE, field, this);
	}

	//----------------------------------------------------------------------

	public void doubleNoteWithoutUndo() {
		if (type == NOTE1) {
			return;
		}
		type /= 2;
		recalculateWidthLength();
	}

	public void doubleNoteWithUndo(Undo undo) {
		if (type == NOTE1) {
			return;
		}
		
		type /= 2;
		recalculateWidthLength();
		undo.makeUndo(Undo.HALVE_NOTE, field, this);
	}

	//----------------------------------------------------------------------

	public void addDotWithoutUndo() {
		if (numDot >= 2) {
			return;
		} else {
			++numDot;
			recalculateWidthLength();
		}
	}

	public void addDotWithUndo(Undo undo) {
		if (numDot >= 2) {
			return;
		} else {
			++numDot;
			recalculateWidthLength();
			undo.makeUndo(Undo.REMOVE_DOT, field, this);
		}
	}

	//----------------------------------------------------------------------

	public void removeDotWithoutUndo() {
		if (numDot > 0) {
			--numDot;
			recalculateWidthLength();
		} else {
			return;
		}
	}

	public void removeDotWithUndo(Undo undo) {
		if (numDot > 0) {
			--numDot;
			recalculateWidthLength();
			undo.makeUndo(Undo.ADD_DOT, field, this);
		} else {
			return;
		}
	}

	//----------------------------------------------------------------------

	public void removeAllModificationWithoutUndo() {
		numDot = 0;
		modification = NOT_MODIFIED;
		staccato = 0;
		recalculateWidthLength();
	}

	public void removeAllModificationWithUndo(Undo undo) {
		int value[] = {numDot, modification, staccato};
		undo.makeUndo(Undo.MODIFY_NOTE, value, field, this);
		removeAllModificationWithoutUndo();
	}

	//----------------------------------------------------------------------

	public void modifyNoteWithUndo(int m, Undo undo) {
		int value[] = {numDot, modification, staccato};
		modifyNoteWithoutUndo(m);
		undo.makeUndo(Undo.MODIFY_NOTE, value, field, this);
	}

	public void modifyNoteWithoutUndo(int m) {

		if (m == NOT_MODIFIED || m == NATURAL) {
			modification = m;
		} else {
			int p = pitch % 12;
			if (m == SHARP) {
				if (p == 0 || p == 2 || p == 5 || p == 7 || p == 9) {
					modification = m;
				} else if (p == 4 || p == 11) {
					modification = NOT_MODIFIED;
				} else {
					Main.failwith("wrong pitch? sharp : " + pitch);
				}
			} else if (m == FLAT) {
				if (p == 2 || p == 4 || p == 7 || p == 9 || p == 11) {
					modification = m;
				} else if (p == 0 || p == 5) {
					modification = NOT_MODIFIED;
				} else {
					Main.failwith("wrong pitch? flat : " + pitch);
				}
			} else {
				Main.failwith("modifyNote : " + m);
			}
		}
		
		recalculateWidthLength();

	}

	//----------------------------------------------------------------------

	boolean isOnNotehead(int x, int relativeY) {
		int y = -1;

		if (field.cref == Field.TREBLE) {
			if (pitch <= 48 || 84 <= pitch ) {
				return false;
			} else {
				y = -35 * ((pitch - 48) / 12 - 1) + pitchPositionY[(pitch - 48) % 12];
			}
		} else if (field.cref == Field.BASS) {
			if (pitch < 28 || 62 < pitch) {
				return false;
			} else {
				y = -35 * ((pitch - 24) / 12 - 1) + pitchPositionY[(pitch - 24) % 12] + 10;
			}
		}

		Main.debugPrint(2, "isOnNotehead");
		Main.debugPrint(2, "y         : " + y);
		Main.debugPrint(2, "relativeY : " + relativeY);

		return (y - 3 <= relativeY && relativeY <= y + 9);
	}

	//----------------------------------------------------------------------

	// ʳʬϡ褦ˤ롣
	public void paintNotehead() {

		Graphics g = Main.getGraphics();
		int y = getY();

		switch (type) {
		case NOTE1:
		case NOTE2:
			g.drawImage(Main.noteheadImage2, horizonPosition, y, 12, 10, Main.root.mainPanel);
			break;
		case NOTE4:
		case NOTE8:
		case NOTE16:
		case NOTE32:
			g.drawImage(Main.noteheadImage, horizonPosition, y, 12, 10, Main.root.mainPanel);
			break;
		default:
			Main.failwith("paintNotehead() : wrongtype");
		}

		if (staccato != 0) {
			g.fillOval(horizonPosition + 4, y + 12, 4, 4);
		}

		switch (modification) {
		case SHARP:
			g.drawImage(sharpImage, horizonPosition - 10, y - 5, 10, 20, Main.root.mainPanel);
			break;
		case FLAT:
			g.drawImage(flatImage, horizonPosition - 10, y - 10, 10, 20, Main.root.mainPanel);
			break;
		case NATURAL:
			g.drawImage(naturalImage, horizonPosition - 10, y - 5, 10, 20, Main.root.mainPanel);
			break;
		default:
			break;
		}

		switch (numDot) {
		case 2:
			g.fillOval(horizonPosition + 19, y + 2, 4, 4);
		case 1:
			g.fillOval(horizonPosition + 13, y + 2, 4, 4);
		}

		if (field.cref == Field.TREBLE) {
			int fy = field.getY();
			int x = horizonPosition - 5;

			System.out.println("TREBLE : " + x + " FY : " + fy);

			if (pitch <= 60) {
				if (pitch <= 50) {
					g.drawLine(x, fy + 120, x + 20, fy + 120);
				}
				if (pitch <= 53) {
					g.drawLine(x, fy + 110, x + 20, fy + 110);
				}
				if (pitch <= 57) {
					g.drawLine(x, fy + 100, x + 20, fy + 100);
				}
				if (pitch <= 60) {
					g.drawLine(x, fy + 90, x + 20, fy + 90);
				}
			}

			if (pitch >= 81) {
				g.drawLine(x, fy + 30, x + 20, fy + 30);
			}

		} else if (field.cref == Field.BASS) {
			int fy = field.getY();
			int x = horizonPosition - 5;

			System.out.println("TREBLE : " + x + " FY : " + fy);

			if (pitch <= 40) {
				if (pitch <= 29) {
					g.drawLine(x, fy + 120, x + 20, fy + 120);
				}
				if (pitch <= 33) {
					g.drawLine(x, fy + 110, x + 20, fy + 110);
				}
				if (pitch <= 36) {
					g.drawLine(x, fy + 100, x + 20, fy + 100);
				}
				if (pitch <= 40) {
					g.drawLine(x, fy + 90, x + 20, fy + 90);
				}
			}

			if (pitch >= 60) {
				g.drawLine(x, fy + 30, x + 20, fy + 30);
			}
		} else {
			Main.failwith("paintNotehead");
		}
	}

	//----------------------------------------------------------------------

	public void paintNote() {

		Graphics g = Main.getGraphics();
		int y = getY();

		switch (type) {
		case NOTE1:
			break;
		case NOTE2:
			if (isVerticalLineUpside()) {
				g.drawLine(horizonPosition + 11, y, horizonPosition + 11, y - 30);
			} else {
				g.drawLine(horizonPosition, y + 5, horizonPosition, y + 35);
			}
			break;
		case NOTE4:
			if (isVerticalLineUpside()) {
				g.drawLine(horizonPosition + 11, y, horizonPosition + 11, y - 30);
			} else {
				g.drawLine(horizonPosition, y + 5, horizonPosition, y + 35);
			}
			break;
		case NOTE8:
			if (isVerticalLineUpside()) {
				g.drawImage(barbaImage, horizonPosition + 12, y - 30, 10, 29, Main.root.mainPanel);
				g.drawLine(horizonPosition + 11, y, horizonPosition + 11, y - 30);
			} else {
				g.drawImage(revbarbaImage, horizonPosition + 1, y + 6, 10, 29, Main.root.mainPanel);
				g.drawLine(horizonPosition, y + 5, horizonPosition, y + 35);
			}
			break;
		case NOTE16:
			if (isVerticalLineUpside()) {
				g.drawImage(barbaImage2, horizonPosition + 12, y - 30, 10, 37, Main.root.mainPanel);
				g.drawLine(horizonPosition + 11, y, horizonPosition + 11, y - 30);
			} else {
				g.drawImage(revbarbaImage2, horizonPosition + 1, y + 6, 10, 37, Main.root.mainPanel);
				g.drawLine(horizonPosition, y + 5, horizonPosition, y + 35);
			}
			break;
		case NOTE32:
			if (isVerticalLineUpside()) {
				g.drawImage(barbaImage3, horizonPosition + 12, y - 30, 10, 37, Main.root.mainPanel);
				g.drawLine(horizonPosition + 11, y, horizonPosition + 11, y - 30);
			} else {
				g.drawImage(revbarbaImage3, horizonPosition + 1, y + 6, 10, 37, Main.root.mainPanel);
				g.drawLine(horizonPosition, y + 5, horizonPosition, y + 35);
			}
			break;
		default:
			break;
		}

		paintNotehead();
	}
	
}


